include file.e
include wildcard.e
include msgbox.e

with trace

atom rtn_code
sequence from_color, to_color, xpm_names

from_color = {"black","dark slate grey","slate grey","grey",
            "dark slate gray","slate gray","gray",
            "gainsboro","white",
            "firebrick","red","tomato","orange","gold","yellow","sienna","peru",
            "khaki4","tan","wheat","lemon chiffon","sea green","lime green",
            "pale green","green","light sea green","cyan","navy","dodger blue",
            "sky blue","blue","lavender","purple","magenta","violet","peach puff",
            "darkOliveGreen1","sandy brown","Gainsboro","brown","CornflowerBlue"}
to_color = {"black","dark_slate_grey","slate_grey","grey",
            "dark_slate_grey","slate_grey","grey",
            "gainsboro","white",
            "firebrick","red","tomato","orange","gold","yellow","sienna","peru",
            "khaki4","tan","wheat","lemon_chiffon","sea_green","lime_green",
            "pale_green","green","light_sea_green","cyan","navy","dodger_blue",
            "sky_blue","blue","lavender","purple","magenta","violet","peach_puff",
            "darkOliveGreen1","sandy_brown","gainsboro","brown","dodger_blue"}

procedure check_dir(sequence directory, sequence file_name)
    object dir_list, line
    atom file_handle, xpm_file, at, write, static, c_char, index, ext
    sequence xpm_name
    file_handle = 0
    dir_list = dir(directory)
    xpm_names = {}
    if sequence(dir_list) then
        for i = 1 to length(dir_list) do
            if not equal(dir_list[i][D_NAME],".") and not equal(dir_list[i][D_NAME],"..") then
                if equal(dir_list[i][D_ATTRIBUTES],"d") then
                    check_dir(directory & "\\" & dir_list[i][D_NAME], 
                        dir_list[i][D_NAME])
                else
                    if wildcard_file("*.xpm",dir_list[i][D_NAME]) then
                        if not file_handle then
                            file_handle = open(directory & "\\" & file_name & ".e", "w")
                            puts(file_handle, "include aiconsct.e\n\n")
                        end if
                        xpm_file = open(directory & "\\" & dir_list[i][D_NAME], "r")
                        line = gets(xpm_file)
                        while sequence(line) do
                            write = 0
                            static = match("static char *", line)
                            if not static then
                                static = match("static String",line)
                            end if
                            if length(line) >= 14 and static then
                                at = find('[',line)
                                if at then
                                    xpm_name = line[14..at-1]
                                    c_char = find('.',xpm_name)
                                    if c_char then
                                        xpm_name[c_char] = '_'
                                    end if
                                    c_char = find('-',xpm_name)
                                    if c_char then
                                        xpm_name[c_char] = '_'
                                    end if
                                    index = find(xpm_name,xpm_names)
                                    ext = 1
                                    while index do
                                        xpm_name = xpm_name & "_" & sprintf("%0d",ext)
                                        index = find(xpm_name,xpm_names)
                                        ext += 1
                                    end while
                                    xpm_names = append(xpm_names,xpm_name)
                                    line = "global constant " & xpm_name & " = {\n"
                                    write = 1
                                else
                                    puts(1, "name error in file " & dir_list[i][D_NAME] &
                                        " in directory " & directory)
                                    abort(1)
                                end if
                            elsif line[1] = '"' then
                                write = 1
                                at = match("\t",line)
                                while at do
                                    line[at] = ' '
                                    at += 1
                                    at = match("\t",line)
                                end while
                                for x = 1 to length(from_color) do
                                    at = match(from_color[x],line)
                                    c_char = match(" c ",line)
                                    if c_char = 2 then
                                        c_char = find('c',line[3..length(line)])
                                        if c_char then
                                            c_char += 2
                                        else
                                            c_char = 0
                                        end if
                                    end if
                                    if at and c_char then
                                        line = line[1..c_char+2] & "\" & " & to_color[x] & ",\n"
                                        exit
                                    end if
                                end for
                                at = match("};",line)
                                if at then
                                    line = line[1..at-1] & "}\n\n"
                                end if
                            elsif match("};",line) then
                                at = match("};",line)
                                line = line[1..at-1] & "}\n\n"
                                write = 1
                            end if
                            if write then
                                while length(line) > 101 do
                                    puts(file_handle, line[1..101] & "\" & \n")
                                    line = "\"" & line[102..length(line)]
                                end while
                                puts(file_handle, line)
                            end if
                            line = gets(xpm_file)
                        end while
                        close(xpm_file)
                    end if
                end if
            end if
        end for
        if file_handle then
            close(file_handle)
        end if
    end if
end procedure

check_dir("c:\\eutools\\test", "test")

